// Italk Protocol 1.0 and biff-port support modifications.
// Copyright (C) 1998, SAKAMOTO Takahiro <takas@is.s.u-tokyo.ac.jp>

/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// WItalk2Message.h


#include	<winsock2.h>
#include	<stdlib.h>
#include	<time.h>
#include	<process.h>
#include	"lgFiles.h"
#include	"WItalk2.h"
#include	"DialogParanoia1.h"
#include	"DialogKillName.h"
#include	"WinDLL.h"

#include	"BackLogWindow.h"
#include	"ProfileManager.h"

#include	<string>
using namespace std;

#define		WAIT_MUTEX_LOG	      WaitForSingleObject(mutex_log    , INFINITE)
#define		WAIT_MUTEX_ADD_LOG    WaitForSingleObject(mutex_add_log, INFINITE)
#define		RELEASE_MUTEX_LOG     ReleaseMutex(mutex_log)
#define		RELEASE_MUTEX_ADD_LOG ReleaseMutex(mutex_add_log)

extern		bool sent_handle;					// Waffle 0.1.11: j~tO
extern		WItalk2* witalk2_ptr;				// Waffle 0.1.11: g
extern		bool foundFirstSubroom;				// Waffle 0.1.12a: ŏ̃Tu[ɃOC
WItalk2* witalk2_ptr;

extern		int	ViewNormalTelegram, ViewSubroomTelegram, AutoOpenNormalTelegram, AutoOpenSubroomTelegram, DoesAutoLogin, AutoLoginStyle;						// OC` (0 = ftHg̃Tu[̂ / 1 = SẴTu[)
extern		int	selectedIndex;

extern		void setPeerTelegramWindowTitle(HWND, ItalkInfo::User*);
extern		void wmCommandUserTelegram();
extern		int	defSubroomNo;

// 
void WItalk2::message_init(void)
{
	ping.clear();
	is_backloging = FALSE;
	handle.clear();

	/* Waffle 0.1.11 */
	witalk2_ptr = this;

	last_userno_who_send_to_me = -1;
	last_userno_to_whom_i_send = -1;
	private_time.clear();
	private_ping_interval = 5 * 60;

	time_t tt = time(NULL);
	struct tm *t = localtime(&tt);
	previous_private_time = (t->tm_hour * 60 + t->tm_min) * 60 + t->tm_sec;

	mutex_log = CreateMutex(NULL, FALSE, NULL);
	mutex_add_log = CreateMutex(NULL, FALSE, NULL);
	event_log_added = CreateEvent(NULL, FALSE, FALSE, NULL);
	log_thread_mode = log_thread_running;

	// para 0.1.0: RpCIvV /MT (}`Xbh LIBCMT ̎gp) Kv
	/*registerThread(*/_beginthread(log_thread, 0, this)/*)*/;
}


// log_thread I
// TRUE: I FALSE: IĂȂ
BOOL WItalk2::terminate_log_thread(void)
{
	switch (log_thread_mode) {
	case log_thread_running:
		log_thread_mode = log_thread_terminating;
		// fall through
	case log_thread_terminating:
		SetEvent(event_log_added);
		return FALSE;
	case log_thread_terminated:
	default:
		return TRUE;
	}
}


// Ƃ܂BO terminate_log_thread Ă log_thread I
// ĂȂ΂ȂȂB
void WItalk2::message_end(void)
{
	SetEvent(event_log_added);

	WAIT_MUTEX_LOG;
	if (!log_buffer.empty()) log_save_log();
	untreated_log.clear();
	RELEASE_MUTEX_LOG;

	WAIT_MUTEX_ADD_LOG;

	clear_kill_name_list();
	clear_biff_sounds();
	ping.clear();
	private_time.clear();
	handle.clear();

	RELEASE_MUTEX_ADD_LOG;

	CloseHandle(mutex_log);
	CloseHandle(mutex_add_log);
	CloseHandle(event_log_added);
}


// connected ̎
void WItalk2::message_connected(void)
{
	WAIT_MUTEX_ADD_LOG;

	is_backloging = FALSE;

	last_userno_who_send_to_me = -1;
	last_userno_to_whom_i_send = -1;
	private_time.clear();

	read_registry_for_ping();
	read_registry_for_kill_name();

	RELEASE_MUTEX_ADD_LOG;
}


// nhς
void WItalk2::change_handle(const wchar_t *_handle)
{
	WAIT_MUTEX_ADD_LOG;

	if (_handle != handle) handle = wstring(_handle);
	wchar_t buf[BUFSIZE];
	wcscpy(buf, L"*ping*");
	wcscat(buf, handle.c_str());
	ping = wstring( buf );

	RELEASE_MUTEX_ADD_LOG;
}


// Kill Name XgNA
void WItalk2::clear_kill_name_list(void)
{
	WAIT_MUTEX_ADD_LOG;
	kill_name_list.clear();
	RELEASE_MUTEX_ADD_LOG;
}


// Kill Name ̃WXgǂ
void WItalk2::read_registry_for_kill_name(void)
{
	_ASSERT( m_pProfileManager );
	WAIT_MUTEX_ADD_LOG;

	clear_kill_name_list();

	wchar_t buf2[BUFSIZE] = L"([";
	wchar_t buf[BUFSIZE] = L"(\?\?:\?\?:\?\?)[";
	for (int i = 0; ; i++) {
		char name[BUFSIZE];
		sprintf(name, "KillName%d", i);
		if (!m_pProfileManager->Read(name, buf + 11, ArrayNum(buf) - 11)) break;
		wcscat(buf, L"]*");
		//kill_name_list.Add(new_string(buf));
		kill_name_list.push_back( wstring(buf) );

		// Waffle 0.2.0f-Rev C: killname 
		if (!m_pProfileManager->Read(name, buf2 + 2, ArrayNum(buf2) - 2)) break;
		wcscat(buf2, L"*] *)");
		//kill_name_list.Add(new_string(buf2));
		kill_name_list.push_back(wstring(buf2));
	}

	RELEASE_MUTEX_ADD_LOG;
}


// BIFF  XgNA
void WItalk2::clear_biff_sounds(void)
{
	WAIT_MUTEX_ADD_LOG;
	biff_sounds.clear();
	RELEASE_MUTEX_ADD_LOG;
}


// BIFF ̃WXgǂ
void WItalk2::read_registry_for_biff_sounds(void)
{
	_ASSERT( m_pProfileManager );
	WAIT_MUTEX_ADD_LOG;

	clear_biff_sounds();

	for (int i = 0; ; i++) {
		char name[BUFSIZE];
		sprintf(name, "SoundPattern%d", i);
		wchar_t buf[BUFSIZE];
		if (!m_pProfileManager->Read(name, buf, ArrayNum(buf))) break;
		biff_sounds.push_back( wstring(buf));
	}

	RELEASE_MUTEX_ADD_LOG;
}


// ping pɃWXgǂ
void WItalk2::read_registry_for_ping(void)
{
	_ASSERT( m_pProfileManager );
	WAIT_MUTEX_ADD_LOG;

	// ping
	if (!handle.empty()) {
		change_handle(handle.c_str());
	} else {
		wchar_t buf[BUFSIZE];
		m_pProfileManager->Read("Handle", buf, sizeof(buf), L"");
		change_handle(buf);
	}

	// ping beep
	char buf[BUFSIZE];
	if (m_pProfileManager->Read("PingSound", buf, sizeof(buf))) {
		ping_beep.Decode(buf);
	} else {
		int sound;
		m_pProfileManager->Read("PingBeep", sound, MB_OK);
		m_pProfileManager->Read("PingBeepFile", buf, sizeof(buf));
		ping_beep.Set(sound, buf);
	}

	// /p ŏ ping
	m_pProfileManager->Read("PrivatePingInterval", private_ping_interval, 5 * 60);

	// BIFF
	read_registry_for_biff_sounds();

	RELEASE_MUTEX_ADD_LOG;
}

// ping 炷
void WItalk2::play_ping(void){ play_ping(true); }

void WItalk2::play_ping(bool f)
{
	WAIT_MUTEX_ADD_LOG;

	ping_beep.Play();
	if (f && IsIconic(Hwnd())){
		// EBhEX^C WS_EX_TOOLWINDOW  WS_EX_APPWINDOW ɕύX
		SetWindowLongPtr(Hwnd(), GWL_EXSTYLE, (GetWindowLongPtr(Hwnd(), GWL_EXSTYLE) | WS_EX_APPWINDOW) & (~WS_EX_TOOLWINDOW));
		ShowWindow(Hwnd(), SW_RESTORE);
	}

	RELEASE_MUTEX_ADD_LOG;
}


// Oɒǉ
//
//   wstring& ł͔p~\  string& łɈڍs
//
void WItalk2::add_log(const wstring& str)
{
	WAIT_MUTEX_LOG;

	log_buffer.push_back(str);
	untreated_log.push_back(str);

	RELEASE_MUTEX_LOG;

	SetEvent(event_log_added);
}

//
// string& : ݂ dispatch 邾CIɂ͂ĐVK[`Ƃčւ
//
void WItalk2::add_log(const string& str)
{
	size_t		wlen = mbstowcs(NULL, str.c_str(), str.size());
	if (wlen <= 0) return;
	wchar_t*	wstr = (wchar_t*)_alloca(wlen*sizeof(wchar_t)+1);
	mbstowcs(wstr, str.c_str(), str.size()+1);
	wstring		ws(wstr);
	add_log(ws);
}


// Users NGXg
void WItalk2::InfoUpdateRequest( bool imm, bool reset )
{
	static bool is_first = FALSE;

	if ( italkProtocolVersion >= 0x0100 || infoUpdate != infoUpdateUseWA ) return;
	if ( reset ) {
		is_first = TRUE;
		return;
	}

	WaitForSingleObject(mutex_update, INFINITE);
	if ( imm || is_first ) {
		isInInfoUpdateWait = FALSE;
		is_first = FALSE;
		send_str(L"/wa\r\n");
	} else if ( !isInInfoUpdateWait ) {
		isInInfoUpdateWait = TRUE;
		infoUpdateWaitLine = 5 + (rand() % 10);
	}
	ReleaseMutex(mutex_update);
}

// OǉXbh
void WItalk2::log_thread(void *This)
{
	((WItalk2 *)This)->log_thread();
}
void WItalk2::log_thread(void)
{
	initLocale();
	while (1) {
		WaitForSingleObject(event_log_added, INFINITE);
		while (1) {
			if (log_thread_mode == log_thread_terminating) {
				log_thread_mode = log_thread_terminated;
				return;
			}

			WAIT_MUTEX_LOG;
			//if (untreated_log.Length() == 0)
			if (untreated_log.empty()) {
				ReleaseMutex(mutex_log);
				break;
			}
			//wchar_t *str = untreated_log[0];
			//untreated_log.Delete(0);
			wstring wstr = untreated_log.front();
			untreated_log.pop_front();
			RELEASE_MUTEX_LOG;

			WAIT_MUTEX_ADD_LOG;
			log_thread_add_log(wstr.c_str());
			RELEASE_MUTEX_ADD_LOG;
		}
	}
}

bool sent_handle = false;			// Waffle 0.1.11: OCȎj~
bool foundFirstSubroom = false;		// Waffle 0.1.12a: ŏ̃Tu[ɃOC
bool firstBacklog = true;

// log_thread ̂݌Ă΂
void WItalk2::log_thread_add_log(const wstring& str)
{
	BOOL does_add_log	    = DialogParanoia1::paranoia1_outputtolog;
	BOOL does_add_public_log  = DialogParanoia1::paranoia1_outputtopubliclog;
	BOOL does_add_private_log = FALSE;
	BOOL does_auto_scroll     = menu.IsChecked(rCommandLogAutoScroll);

	wchar_t *match_end;
	const wchar_t *output_to_private = str.c_str();
	wchar_t buf[BUFSIZE], buf2[BUFSIZE];

	bool	delivered = false;

	bool    bSendToLogWindow = false;

	initLocale();

	lineCounter++;

	if (ic.needAnimationStop) lgcAnimation_End(hwnd_anim_connectto);

	// PsڂʂɃ`FbN
	if ( lineCounter == 1 ) {
		updateIconOnTasktray();		// ^XNgC̃c[`bvbZ[W̍XV
		// Waffle 0.1.12a: ǂɂ /login ĂȂƂɂ
		foundFirstSubroom = false;
		sent_handle = false;
		firstBacklog = true;
		// Ƃ肠 subroom gps\ɂĂ
		servercaps_subroom = false;
		defSubroomNo = 0;	// Waffle 0.2.0f
		// Italk Protocol o[W[
		if ( !wcsncmp(str.c_str(), L"# Italk Protocol ", 17) ) {
			italkProtocolVersion = _wtoi(str.c_str()+17) * 0x100;
			for (int i = 17; str[i]; i++) {
				if ( str[i] == L'.' ) {
					italkProtocolVersion |= (_wtoi(str.c_str()+i+1) & 0xff);
					break;
				}
			}
		} else
			italkProtocolVersion = 0;
		// Italk Protocol (Users ̍XV@ݒ)
		if ( italkProtocolVersion < 0x0100 ) {
			infoUpdate = infoUpdateNone;
		} else {
			//send_str(L"/x type=mixed\r\n");
		}
		m_pCurrentLogWindow = NULL;
	} else if (lineCounter == 2) {
		if (str.find(L"# ServerCaps ") == 0) {
			if (str.find(L" subroom") != str.npos) servercaps_subroom = true;
			if (str.find(L" ssl") != str.npos && DialogParanoia1::paranoia1_sslswitching) {
				servercaps_ssl = true;
				send_str(L"/x transport=ssl\r\n");	// SSLڑJnw߂T[oɑ
			}
		}
	}

	if (!sent_handle && lineCounter >= 2) {
		if (servercaps_ssl && !ic.sslMode) {
			// SSLڑJnw߂͑SSLmɂ͎ĂȂ
		} else if (ic.IsConnecting()) {
			if (italkProtocolVersion >= 0x0100) {
				send_str(L"/x type=mixed\r\n");
			}
			// nh𑗂
			if ( !handle.empty() ) {
				if (handle.size()) send_str(handle.c_str()); else send_str(LoadStringW(rStringDefaultHandle));
				send_str(L"\r\n");
	  			/* Waffle 0.1.11: PairSnow Ȃ΁AƂ肠 1 Tu[ɃOCĂ */
			}
			// Users Update ̏
			if ( italkProtocolVersion >= 0x100 ) send_str(L"/wa\r\n"); else InfoUpdateRequest(FALSE,TRUE);
			sent_handle = true;
		}
	}

	// Users (<italk></italk>, "#!", "=!")
	if ( check_italk_info_string(str.c_str()) ) {
		BOOL does_show_wa	  = DialogParanoia1::paranoia1_showwa;
		BOOL does_auto_scroll = menu.IsChecked(rCommandLogAutoScroll);
		if ( does_show_wa && does_add_public_log )
			iv_log_public->AddText(str.c_str(), does_auto_scroll && !is_backloging);
		return;
	}

	// Users ̃NGXg
	if ( italkProtocolVersion < 0x0100 && infoUpdate == infoUpdateUseWA && isInInfoUpdateWait ) {
		WaitForSingleObject(mutex_update, INFINITE);
		if ( infoUpdateWaitLine <= 0 ) {
			isInInfoUpdateWait = FALSE;
			send_str(L"/wa\r\n");
		} else
			infoUpdateWaitLine--;
		ReleaseMutex(mutex_update);
	}

	// Kill Name
	if (DialogKillName::killname){
		
		
		for (unsigned int i = 0; i < kill_name_list.size(); i++)
			if (lgString::DoesMatch(str.c_str(), kill_name_list[i].c_str()))
				return;
		
	}

	// Open URL
	if (lgString::GetURL(buf, sizeof(buf), str.c_str())) url_add(buf);

	// ping
	if ( !is_backloging && lgString::DoesMatch(str.c_str(), ping.c_str()) ) play_ping();

	// inid quickhack thread
	if (italk_info.server.is_inid && lgString::match(str.c_str(), L"^(.*\\:.*\\:.*)\\[.*\\] [0-9]\\:")) {
		lgString::DoesMatch(str.c_str(), L"(*:*:*)[*] ?:", match_end);
		int threadno = *(match_end-2)-0x30;
		if (!lgString::match(str.c_str()+1, L"(.*\\:.*\\:.*)\\[.*\\] [0-9]\\:") && 1 <= threadno  && threadno <= 9) {
			// buf[] ɃTu[zp̃bZ[W\z
			int	subroomno = 10000-threadno;
			wcscpy(buf, str.c_str());
			*(wcschr(buf, L']')+1) = NULL;
			wcscat(buf, L" "); wcscat(buf, match_end);
			// ʃEBhE֔z
			selectedIndex = subroomno;
			HWND	telegramHwnd = SearchTelegramDeliveryTable(subroomno);
			if (telegramHwnd == 0 /*&& AutoOpenSubroomTelegram*/) {
				// ʃEBhEJ
				if (!hwnd_dialog_users) SendMessage(Hwnd(), WM_COMMAND, rCommandOtherUsers, 0);
				SendMessage(hwnd_dialog_users, WM_COMMAND, rCommandUserTelegram, 0);
				telegramHwnd = SearchTelegramDeliveryTable(subroomno);
			}
			if (telegramHwnd) {
				SendMessage(telegramHwnd, WM_COMMAND, rCommandAppendLog, (LPARAM)buf);
				delivered = true;
				output_to_private = buf;
				does_add_public_log  = FALSE;
				does_add_private_log = TRUE;
			}
		}
	}

	// parse
	if ( str[0] == L'#' ) {
		// dE`EBACKLOG
		if (lgString::DoesMatch(str.c_str(), L"#< Message from (", match_end)) {
			last_userno_who_send_to_me = _wtoi(match_end);
			next_p_userno = last_userno_who_send_to_me;

			// Waffle 0.2.0: [Uꗗ̍łɂ郆[U̓dłȂꍇɌXV (XVƃTu[łƂ)
			ItalkInfo::User* itusertop = italk_info.GetUserFromIndex(0);
			int	last_last_userno_who_send_to_me = itusertop->userno;
			if (last_last_userno_who_send_to_me != last_userno_who_send_to_me){
				italk_info.Raise(last_userno_who_send_to_me);
				dialog_users_update();
			}
			private_time.clear();
			wcscpy(buf, str.c_str());
			if (lgString::DoesMatch(str.c_str(), L"#< Message from (??\?\?) [*] @ *(*) ", match_end)) {
				wchar_t *s = wcschr(match_end, ' ');
				if (s) {
					*s = '\0';
					private_time = wstring(match_end);
					int _previous_private_time = 
						(_wtoi(match_end) * 60 + _wtoi(match_end + 3)) * 60
						+ _wtoi(match_end + 6);
			
					int d = _previous_private_time - previous_private_time;

					if (d < 0)
						d += 24 * 60 * 60;
					if (private_ping_interval < d){ // 鎞ԈȏoĂ炷
						/* Waffle 0.1.12: Tu[Ȃ炳Ȃ */
						if (!servercaps_subroom || last_userno_who_send_to_me < 9900){
							play_ping(); 
						}
					}
					previous_private_time = _previous_private_time;
				}
			}
			does_add_public_log  = FALSE;
		} else if (lgString::DoesMatch(str.c_str(), L"#< ", match_end))  {
			if (last_userno_who_send_to_me == -1) {	// `
				output_to_private = str.c_str();
			} else {					// 󂯎d
		  /* Waffle 0.1.11: subroom vgR΍
		     bIɁA9900 Ԉȏ uid ̓d subroom ƂďAʏ픭̂悤ɕ\B */
				if (!(servercaps_subroom && last_userno_who_send_to_me > 9900)){		// ʃ[Ud
					swprintf(buf, L"#<%04d(%s)[%s] %s", last_userno_who_send_to_me, !private_time.empty() ? private_time.c_str() : L"??:??:??",
						italk_info.GetHandle(last_userno_who_send_to_me), match_end);
					// Waffle 0.2.0: ʃEBhE֔z
					{
						HWND	telegramHwnd = SearchTelegramDeliveryTable(last_userno_who_send_to_me);
						if (telegramHwnd == 0 && AutoOpenNormalTelegram){
							// ʃEBhEJ
							selectedIndex = 0;// Kŏʂ̃[U
							if (!hwnd_dialog_users){
								// ܂ Users _CAOJ
								SendMessage(Hwnd(), WM_COMMAND, rCommandOtherUsers, 0);	
							}
							// ʃEBhEJ
							SendMessage(hwnd_dialog_users, WM_COMMAND, rCommandUserTelegram, 0);
							telegramHwnd = SearchTelegramDeliveryTable(last_userno_who_send_to_me);
						}
						if (telegramHwnd != 0){
							wchar_t	telbuf[BUFSIZE];
							swprintf(telbuf, L"(%s)[%s] %s", !private_time.empty() ? private_time.c_str() : L"??:??:??", italk_info.GetHandle(last_userno_who_send_to_me), match_end);
							SendMessage(telegramHwnd, WM_COMMAND, rCommandAppendLog, (LPARAM)telbuf);
							if (ViewNormalTelegram){
								delivered = false;
							}else{
								delivered = true;
							}
						}
					}
					output_to_private = buf;
				} else {// Tu[d
					//swprintf(buf, L"(%s)%s", private_time ? private_time : L"??:??:??", match_end);
					// Waffle 0.2.0e: [Ou
					swprintf(buf, L"%s", match_end);
					if (last_userno_who_send_to_me != defSubroomNo){
						ItalkInfo::User* user = italk_info.GetUser(last_userno_who_send_to_me);			  
						swprintf(buf2, L"[%s]%s", user->handle.c_str(), match_end);
					}
					// Waffle 0.2.0: ʃEBhE֔z
					{
						HWND	telegramHwnd = SearchTelegramDeliveryTable(last_userno_who_send_to_me);
						if (telegramHwnd == 0 && AutoOpenSubroomTelegram){
							// ʃEBhEJ
							selectedIndex = 0;// Kŏʂ̃[U
							if (!hwnd_dialog_users){
								SendMessage(Hwnd(), WM_COMMAND, rCommandOtherUsers, 0);	// ܂ Users _CAOJ
							}
							SendMessage(hwnd_dialog_users, WM_COMMAND, rCommandUserTelegram, 0);				// ʃEBhEJ
							telegramHwnd = SearchTelegramDeliveryTable(last_userno_who_send_to_me);
						}
						if (telegramHwnd != 0){
							SendMessage(telegramHwnd, WM_COMMAND, rCommandAppendLog, (LPARAM)buf);
							if (ViewSubroomTelegram){
								delivered = false;
							}else{
								delivered = true;
							}
						}
					}
					if (last_userno_who_send_to_me == defSubroomNo)
						output_to_private = buf;
					else
						output_to_private = buf2;
				}
			}
			last_userno_who_send_to_me = -1;
			does_add_public_log  = FALSE;
			does_add_private_log = TRUE;
		} else if (lgString::DoesMatch(str.c_str(), L"#> Message to (", match_end)) {
			last_userno_to_whom_i_send = _wtoi(match_end);

			private_time.clear();
			wcscpy(buf, str.c_str());
			if (lgString::DoesMatch(str.c_str(), L"#> Message to (??\?\?) [*] @ *(*) ", match_end)) {
				wchar_t *s = wcschr(match_end, ' ');
				if (s) {
					*s = '\0';
					private_time = wstring(match_end);
				}
			}
			does_add_public_log  = FALSE;
		} else if (lgString::DoesMatch(str.c_str(), L"#> ", match_end)) {
      if (last_userno_to_whom_i_send == -1) {	// `
		  output_to_private = str.c_str();
      } else {					// 瑗d
		  /* Waffle 0.1.11: subroom vgR΍
		     bIɁA9900Ԉȏ uid ւ̓d subroom ƂďA\ȂB*/
		  if (!(servercaps_subroom && last_userno_to_whom_i_send > 9900)){			// ʃ[Ud
			  swprintf(buf, L"#>%04d(%s)[%s%s] %s", last_userno_to_whom_i_send, !private_time.empty() ? private_time.c_str() : L"??:??:??", handle.c_str(),
				  italk_info.GetHandle(last_userno_to_whom_i_send), match_end);
			  // Waffle 0.2.0: ʃEBhE֔z
			  {
				  HWND	telegramHwnd = SearchTelegramDeliveryTable(last_userno_to_whom_i_send);
 				  if (telegramHwnd == 0 && AutoOpenNormalTelegram){
					  // ʃEBhEJ
					  {
						  // M userno  italk_info ł index 𒲂ׂ
						  ItalkInfo::User* user = 0;
						  for (int i = 0; ; i++){
							  if ((user = italk_info.GetUserFromIndex(i)) == 0) break;
							  if (user->userno == last_userno_to_whom_i_send){ selectedIndex = i; break; }
						  }
						  if (user == 0) goto failed_to_find;
					  }
					  if (!hwnd_dialog_users) SendMessage(Hwnd(), WM_COMMAND, rCommandOtherUsers, 0);		// ܂ Users _CAOJ
					  SendMessage(hwnd_dialog_users, WM_COMMAND, rCommandUserTelegram, 0);					// ʃEBhEJ
					  telegramHwnd = SearchTelegramDeliveryTable(last_userno_to_whom_i_send);
				  }
failed_to_find:
				  if (telegramHwnd != 0){
					  wchar_t	telbuf[BUFSIZE];
					  swprintf(telbuf, L"(%s)[%s] %s", !private_time.empty() ? private_time.c_str() : L"??:??:??", handle.c_str(), match_end);
					  SendMessage(telegramHwnd, WM_COMMAND, rCommandAppendLog, (LPARAM)telbuf);
					  if (ViewNormalTelegram) delivered = false; else delivered = true;
				  }
			  }
			  output_to_private = buf;
		  } else {			// Tu[d
			  last_userno_to_whom_i_send = -1; does_add_public_log = does_add_private_log = FALSE;
			  // Waffle 0.2.0: ʃEBhE֔z
			  {
				  HWND	telegramHwnd = SearchTelegramDeliveryTable(last_userno_to_whom_i_send);
				  if (telegramHwnd != 0){
					  SendMessage(telegramHwnd, WM_COMMAND, rCommandAppendLog, (LPARAM)buf);
					  // Tu[̔Ȃ̂ŁAcȂĂƂƂɂB
					  delivered = true;
				  }
			  }
			  output_to_private = buf; *buf = 0;
			  goto skip_savelogset;
		  }
      }
      last_userno_to_whom_i_send = -1;
      does_add_public_log  = FALSE;
      does_add_private_log = TRUE;
skip_savelogset: ;
		} else if (lgString::DoesMatch(str.c_str(), L"## __ BACK LOG START _____________________")) {
			// obNOEBhEJ
			{
				//lgRegistry	regs(REGISTRY_ROOT);
				int		backlogsplit;
				m_pProfileManager->Read("BacklogSplit", backlogsplit, false);
				if( !firstBacklog && sent_handle && backlogsplit ){
					SendMessage( Hwnd(), WM_COMMAND, rCommandOpenBackLogWindow, 0 );
				}
			}
			// obNOEBhEɒǉ
			if( m_pCurrentLogWindow ){
				//m_pCurrentLogWindow->AddLog( str );
				iv_log_public->AddText(str.c_str(), true);
			}
			// SĂ inid thread EBhEɒǉ
			if (italk_info.server.is_inid) {
				HWND	hwndTh;
				for (int i = 9990; i < 10000; i++) if (hwndTh = SearchTelegramDeliveryTable(i)) {
					PostMessage(hwndTh, WM_COMMAND, rCommandAppendLog, (LPARAM)str.c_str());
				}
			}
			// Waffle 0.2.0b: obNOI[gXN[~߂ȂݒɂȂĂ邩𒲂ׂ
			//lgRegistry	reg(REGISTRY_ROOT);
			int		NonStopAutoScrollInBacklog;
			m_pProfileManager->Read("NonStopAutoScrollInBacklog", NonStopAutoScrollInBacklog, false);
			if (NonStopAutoScrollInBacklog) is_backloging = false; else is_backloging = true;
		} else if (lgString::DoesMatch(str.c_str(), L"## -- BACK LOG END -----------------------")) {
			is_backloging = FALSE;
			bSendToLogWindow = true;
			sent_handle = true;					// Waffle 0.1.11: j~̉
			if( m_pCurrentLogWindow ){
				m_pCurrentLogWindow->AddLog( str.c_str(), true );
				m_pCurrentLogWindow = NULL;
			}
			// SĂ inid thread EBhEɒǉ
			if (italk_info.server.is_inid) {
				HWND	hwndTh;
				for (int i = 9990; i < 10000; i++) if (hwndTh = SearchTelegramDeliveryTable(i)) {
					PostMessage(hwndTh, WM_COMMAND, rCommandAppendLog, (LPARAM)str.c_str());
				}
			}
			firstBacklog = false;
		}
	} else if ( str[0] == L'(' && str[1] == L'[' ) {
		// /wa  BIFF
		BOOL is_logged_in = lgString::DoesMatch(str.c_str(), L"([*] logged in");
		BOOL is_handle_ch = lgString::DoesMatch(str.c_str(), L"([*] handle change [", match_end);
		if (!is_backloging && (is_logged_in || is_handle_ch)) { // BIFF
			const wchar_t* cmatch_end = match_end;
			if (is_logged_in)
				cmatch_end = str.c_str() + 2;
			
			
			for (unsigned int i = 0; i < biff_sounds.size(); i++) {
				wcscpy(buf, biff_sounds[i].c_str());
				wchar_t *t = wcschr(buf, L'\t');
				if (t)
					*t= '\0';
				if (is_handle_ch && wcsequal(buf, L"*"))
					continue;
				wcscat(buf, is_logged_in ? L"@*]" : L"]");
				if (lgString::DoesMatch(cmatch_end, buf)) {
					char mbsbuf[BUFSIZE] = "\0";
					if (t)
						wcstombs(mbsbuf, biff_sounds[i].c_str() + (t + 1 - buf), sizeof(mbsbuf));
					Sound sound;
					sound.Decode(mbsbuf);
					sound.Play();
					break;
				}
			}
			
		}
		if ( !is_backloging )
			InfoUpdateRequest();
	} else if ( str[0] == L'/' && lgString::DoesMatch(str.c_str(), L"/d who")) {
		// fobO
		int i = 0;
		while (italk_info.GetUsersStringForDebug(i++, buf, sizeof(buf)))
			iv_log_public->AddText(buf, menu.IsChecked(rCommandLogAutoScroll));
	}
	if( m_pCurrentLogWindow ){
		m_pCurrentLogWindow->AddLog( str.c_str(), does_auto_scroll );
	}else{
		// Oǉ
		if (does_add_public_log)
			iv_log_public->AddText(str.c_str(), does_auto_scroll && !is_backloging);
	}
	// ʃEBhEɔzꂽꍇ͕\Ȃ
	if (!delivered && does_add_private_log && menu.IsChecked(rCommandLogOutputToPrivateLog))
		iv_log_public->AddText(output_to_private, does_auto_scroll);
}


// Wafle 0.2.0: w肳ꂽ񂪃Tu[̂̂𔻒
bool	prevLineWasTelegramFirstLine = false;
bool	prevLineWasTelegramToSubroom = false;

bool isNotFromSubroom(char* buf)		/* Tu[̎MłȂ true Ԃ */
{
	if (prevLineWasTelegramFirstLine){ prevLineWasTelegramFirstLine = false; return false; }
	int		slen = strlen(buf);
	if (slen < 23) return true;
	if (strncmp(buf, "#< Message from (", 17) != 0) return true;
	long	userno = atol(buf+17);
	if (userno >= 9900){ prevLineWasTelegramFirstLine = true; return false; }
	return true;
}

bool isNotToSubroom(char* buf)			/* Tu[ւ̑MłȂ true Ԃ */
{
	if (prevLineWasTelegramToSubroom){ prevLineWasTelegramToSubroom = false; return false; }
	int		slen = strlen(buf);
	if (slen < 23) return true;
	if (strncmp(buf, "#> Message to (", 15) != 0) return true;
	long	userno = atol(buf+15);
	if (userno >= 9900){ prevLineWasTelegramToSubroom = true; return false; }
	return true;
}

// Ot@CփZ[u
void WItalk2::log_save_log(void)
{
	_ASSERT( m_pProfileManager );
	int value;
	m_pProfileManager->Read("DoesSaveLog", value, FALSE);
	if (!value) return;
	char buf[BUFSIZE];
	m_pProfileManager->Read("LogSaveFolder", buf, sizeof(buf), windll.logSaveFolder.c_str());
	if (buf[0] == '\0') return;
	m_pProfileManager->Read("LogSavePrivateOnly", value, TRUE);
	BOOL does_private_only = value;

#if 0
	if (lgFiles::MakeDirectory(buf)) {	// fBNgVKɍ쐬
		char	fbuf[BUFSIZE];
		sprintf(fbuf, "%s\\Desktop.ini", windll.logSaveFolder.c_str());
		char	fname[BUFSIZE];
		GetModuleFileName(NULL, fname, sizeof(fname));
		char	defname[BUFSIZE];
		ExpandEnvironmentStrings(lgWindows::LoadString(rStringDefInstallExe), defname, sizeof(defname));
		if (_stricmp(fname, defname) == 0) {
			DWORD	written = 0;
			HANDLE	bx = CreateFile(fbuf, GENERIC_READ | GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM, NULL);
			if (bx != INVALID_HANDLE_VALUE) {
				WriteFile(bx, lgWindows::LoadString(rStringDesktopini), strlen(lgWindows::LoadString(rStringDesktopini)), &written, NULL);
				CloseHandle(bx);
			}
		}
	}
#endif
	int len = strlen(buf);
	strcpy(buf + len, "\\");
	len++;

	time_t t = time(NULL);
	struct tm *lt = localtime(&t);
	strftime(buf + len, sizeof(buf) - len, LoadString(rStringLogSaveName), lt);

	FILE *fp = fopen(buf, "ab");
	if (fp) {
		HCURSOR hcur = SetCursor(LoadCursor(NULL, IDC_WAIT));
		char buf[BUFSIZE * 4];

		WAIT_MUTEX_LOG;
		//while (log_buffer.Length())
		while( !log_buffer.empty() ) {
			wcstombs(buf, log_buffer.front().c_str() , sizeof(buf));
			// Waffle 0.2.0: Tu[OvCx[gOɍĕۑȂ悤ɂ
			if ((does_private_only && isNotFromSubroom(buf) && isNotToSubroom(buf) && (buf[0] == '#' && (buf[1] == '>' || buf[1] == '<'))) ||
				!does_private_only) {
					fputs(buf, fp);
			}

			log_buffer.pop_front();
		}
		RELEASE_MUTEX_LOG;

		fclose(fp);

		SetCursor(hcur);
	}
}
