// Italk Protocol 1.0 and biff-port support modifications.
// Copyright (C) 1998, SAKAMOTO Takahiro <takas@is.s.u-tokyo.ac.jp>

/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// WItalk2Users.cxx


#include	<winsock2.h>
#include	<crtdbg.h>

#include	"Dialog.h"
#include	"WItalk2.h"
#include	"ProfileManager.h"
#include	"WinDLL.h"


// 
void WItalk2::dialog_users_init(void)
{
	hwnd_dialog_users = NULL;
	next_p_userno = -1;
}


// Ƃ܂
void WItalk2::dialog_users_end(void)
{
	_ASSERT( m_pProfileManager );
	m_pProfileManager->Write("AutoShowUsers",
		hwnd_dialog_users ?
		IsWindowVisible(hwnd_dialog_users) : FALSE);
	if (hwnd_dialog_users) DestroyWindow(hwnd_dialog_users);
	hwnd_dialog_users = NULL;
	next_p_userno = -1;
}


// Users _CAO̍XV
void WItalk2::dialog_users_update(void)
{
	if (hwnd_dialog_users) SendMessage(hwnd_dialog_users, WM_DIALOGNOTIFY, 0, (LPARAM)&italk_info);
}


// ڑƂɕ\邩
void WItalk2::dialog_users_connected(void)
{

	italk_info.Reset();
	if (!hwnd_dialog_users) {
		BOOL does_auto_show_users;

		m_pProfileManager->Read("AutoShowUsers", does_auto_show_users, TRUE);
		if (does_auto_show_users && !hwnd_dialog_users)
			PostMessage(Hwnd(), WM_COMMAND, MAKELONG(rCommandOtherUsers, 0), 0);
	}
}


// EBhẼ[UꗗEBhEON/OFF\ ON ɂ
void WItalk2::dialog_users_menuon()
{
	menu.Check(rCommandOtherUsers, true);
	if (toolbar) toolbar->PressButton(rCommandOtherUsers, true);
}

// EBhẼ[UꗗEBhEON/OFF\ OFF ɂ
void WItalk2::dialog_users_menuoff()
{
	menu.Check(rCommandOtherUsers, false);
	if (toolbar) toolbar->PressButton(rCommandOtherUsers, false);
}

// OCĂl̈ꗗ\
void WItalk2::dialog_users_show(void)
{
	BOOL is_first_time = FALSE;
	if (!hwnd_dialog_users) {
		is_first_time = TRUE;
		DialogUsersInit dui;
		dui.hwnd_owner = Hwnd();
		dui.italk_info = &italk_info;
		dui.pProfileManager = getProfileManager();
		hwnd_dialog_users = CreateDialogParam(lgWindows::hInst(), MAKEINTRESOURCE(rDialogUsers), NULL, (DLGPROC)DialogUsersDlgProc, (LPARAM)&dui);
	}
	if (witalk2_ptr->menu.IsChecked(rCommandOtherUsers)) {
		dialog_users_menuoff();
		ShowWindow(hwnd_dialog_users, SW_HIDE);
	} else {
		MoveWindowVisible(hwnd_dialog_users);
		ShowWindow(hwnd_dialog_users, SW_SHOWNA);
		if (is_first_time) SetForegroundWindow(Hwnd());
		dialog_users_menuon();
	}
}


// wmDialogNotify_DialogUsers
void WItalk2::dialog_users_notify(BOOL does_hide)
{
	if (does_hide) { // B
		if (hwnd_dialog_users) ShowWindow(hwnd_dialog_users, SW_HIDE);
	} else InfoUpdateRequest(TRUE);
}


// italk_info ֘A̕`FbN
BOOL WItalk2::check_italk_info_string(const wchar_t *str)
{
	// Biff |[g̓͂ϊ ( Ђǂ) by TYM
	BOOL isBiff = (str[0] == L'=');
	if ( isBiff ) ((wchar_t *)str)[0] = L'#';
	int		r = italk_info.Check(str, !isBiff);
	if ( !r ) return FALSE;
	if ( r < 0 ) return TRUE;		// SSLڑV[PXp

	if ( !italk_info.IsInItalkInfoMode() ) {
		// ^Cg̐ݒ
		ItalkInfo::Server *server = italk_info.GetServer();
		if ( server ) {
			char mbsbuf[BUFSIZE];
			wcstombs(mbsbuf, (server->Host() ? server->Host() : L"?"), sizeof(mbsbuf));
			char buf[BUFSIZE];
 			sprintf(buf, "WItalk2 - %s:%d", mbsbuf, server->Port());
			SetWindowText(buf);
		}
		// nh̎擾
		if ( 0 <= italk_info.WhoAmI() ) {
			const wchar_t *_handle = italk_info.GetHandle(italk_info.WhoAmI());
			if ( _handle ) change_handle(_handle);
		}
		// Users _CAO̍XV
		dialog_users_update();
	}
	return TRUE;
}



// /p ̕⊮ (RichEdit 3.0 )
void WItalk2::complete_p(int direction)
{
	int char_index = iv_input->Re.GetCaretIndex();
	int start_index = -1;
	int end_index = -1;
	wchar_t *line = iv_input->Re.newGetLineW(&start_index, &end_index);
	if (line){
		wchar_t *n = wcsrchr(line, '\r');
		if (n) *n = '\0';

		wchar_t *match_end;
		int userno;
		if (lgString::DoesMatch(line, L"/p ????{*} ", match_end)){
			userno = wcstol(line + 3, 0, 10);
			if (0 < direction) userno = italk_info.GetNextUserNo(userno);
			else if (direction < 0) userno = italk_info.GetPrevUserNo(userno);
			iv_input->Re.SetSel(start_index, start_index + (int)(match_end - line));
			iv_input->Re.Clear();
			char_index -= (int)(match_end - line);
		} else if (lgString::DoesMatch(line, L"/p", match_end)) {
			userno = wcstol(match_end, 0, 10);
			if (0 < direction) userno = italk_info.GetNextUserNo(userno);
			else if (direction < 0) userno = italk_info.GetPrevUserNo(userno);
			match_end = lgString::SkipSpace(match_end);
			match_end = lgString::SkipNumber(match_end);
			iv_input->Re.SetSel(start_index, start_index + (int)(match_end - line));
			iv_input->Re.Clear();
			char_index -= (int)(match_end - line);
		} else userno = next_p_userno;
		delete [] line; line = NULL;
		if (char_index < start_index) char_index = start_index;
		iv_input->Re.MoveCaret(char_index);

		// ǉ
		if (userno < 0)	userno = next_p_userno;
		userno = italk_info.GetRightUserNo(userno);
		int char_index = iv_input->Re.GetCaretIndex();
		wchar_t buf[BUFSIZE];
		if (0 <= userno){
			swprintf(buf, L"/p %04d{", userno);
			int len = wcslen(buf);
			wcscpy(buf + len, italk_info.GetHandle(userno));
			wcscat(buf, L"} ");
		} else wcscpy(buf, L"/p ");
		iv_input->Re.MoveCaret(iv_input->Re.BeginingOfLineCharFromChar(char_index));
		iv_input->Re.Insert(buf);
		if (0 <= userno) iv_input->Re.MoveCaret(char_index + wcslen(buf));
		next_p_userno = userno;
	}
}


// /p 𑗂낤ƂƂɃ`FbN
BOOL WItalk2::check_private_message(wchar_t *line, BOOL &is_private_message)
{
	wchar_t *match_end;

	if (lgString::DoesMatch(line, L"/p ????{*} \r\n") ||
		lgString::DoesMatch(line, L"/p ????{*}\r\n"))
		return FALSE; // Ȃ

	if (lgString::DoesMatch(line, L"/p ????{*} ", match_end))
	{
		match_end--;
		MoveMemory(line + 7, match_end, (wcslen(match_end) + 1) * sizeof(wchar_t));

		next_p_userno = _wtoi(line + 2);
		italk_info.Raise(next_p_userno);
		dialog_users_update();

		is_private_message = TRUE;
	}

	return TRUE; // 
}
