/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// WinDLL.cpp


#include	<winsock2.h>
#include	<windows.h>
#include	<shlobj.h>

#include	"lgWindows.h"
#include	"rWItalk2.h"
#include	"WinDLL.h"

WinDLL	windll;

WinDLL::WinDLL()
{
	{
		OSVERSIONINFO	osver;
		osver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		GetVersionEx(&osver);
		windows_ver = (osver.dwMajorVersion << 8) | osver.dwMinorVersion;
	}
	// NT3.51ł͓삵Ȃ (ԂsłȂ͂Ô)
	if (windows_ver < 0x0400) EXIT_WITH_MSG(lgWindows::LoadString(rStringErrorInvalidVersionOfWindows));
	// RichEdit 2.0 [h
	if (LoadLibrary("RICHED20.DLL") == NULL) EXIT_WITH_MSG(lgWindows::LoadString(rStringErrorRICHED20));
	// SHFOLDER.DLL ̃[hKv (Win2k ȏł GetProcAddress ̊֌WŃ[hKv)
	if ((shfolder_dll = LoadLibrary("SHFOLDER.DLL")) == NULL) {
		_SHGetFolderPath = NULL;
	} else {
		_SHGetFolderPath = (ptrSHGetFolderPath*)GetProcAddress(shfolder_dll, "SHGetFolderPathA");
		char log_folder[MAX_PATH*2], mydoc_folder[MAX_PATH];
		if (_SHGetFolderPath && windll._SHGetFolderPath(NULL, CSIDL_PERSONAL, NULL, NULL, mydoc_folder) == S_OK) {
			sprintf(log_folder, lgWindows::LoadString((windows_ver < 0x0500) ? rStringDefLogFolder9x : rStringDefLogFolder2k), mydoc_folder);
		logSaveFolder.assign(log_folder);
	} else {
		logSaveFolder.assign(".\\");
	}

	}
	// Win2k ȏł͔EBhEp API ւ̃|C^擾
	if (windows_ver >= 0x0500) {
		user32_dll = LoadLibrary("USER32.DLL");		// USER32.DLL[hłȂƂ͂蓾Ȃ͂
		_SetLayeredWindowAttributes = (ptrSetLayeredWindowAttributes*)GetProcAddress(user32_dll, "SetLayeredWindowAttributes");	// Win2kȏŃV{ȂƂ蓾Ȃ͂
	} else {
        user32_dll = 0; _SetLayeredWindowAttributes = NULL;
	}
}


WinDLL::~WinDLL()
{
}
