/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgMenu


#pragma	once

#include	"lgWindows.h"


class lgMenu
{
	HMENU hmenu; // j[nh

public:

	lgMenu(void) : hmenu(NULL) { }
	lgMenu(HMENU _hmenu) : hmenu(_hmenu) { }

	// ۂ̃EBhẼj[Ƃ̃NX֘At
	void SetWindow(HWND hwnd) { hmenu = GetMenu(hwnd); }

	// ۂ̃j[Ƃ̃NX֘At
	void SetMenu(HMENU _hmenu) { hmenu = _hmenu; }

	// j[̍ڂ`FbNĂ邩ǂ
	BOOL IsChecked(int id) { return !!(GetMenuState(hmenu, id, MF_BYCOMMAND) & MF_CHECKED); }

	// j[̍ڂ`FbN^Ȃ
	BOOL Check(int id, BOOL is_checked = TRUE) {
		CheckMenuItem(hmenu, id, is_checked ? MF_CHECKED : MF_UNCHECKED);
		return !!is_checked;
	}

	// j[̃`FbNԂ𔽓]
	BOOL ToggleCheck(int id) { return Check(id, !IsChecked(id)); }

	// j[̍ڂLǂ
	BOOL IsEnabled(int id) {
		return !(GetMenuState(hmenu, id, MF_BYCOMMAND) & (MF_DISABLED | MF_GRAYED));
	}

	// j[̍ڂLɂ^Ȃ
	BOOL Enable(int id, BOOL is_enable = TRUE) {
		EnableMenuItem(hmenu, id, is_enable ? MF_ENABLED : MF_GRAYED);
		return !!is_enable;
	}
};
